#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		debug_package	%{nil}
#-----------------------------------------------------------------------------
Name		:	mbedtls
Version		:	3.5.1
Release		:	17.0.10.rel%{?dist}
Summary		:	Light-weight cryptographic and SSL/TLS library
 
Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	apache-2.0
URL		:	https://www.trustedfirmware.org/projects/mbed-tls
			# https://github.com/Mbed-TLS/

Source0		:	%{name}-%{version}.tar.gz


#-----------------------------------------------------------------------------
BuildRequires	:	cmake
BuildRequires	:	doxygen
BuildRequires	:	gcc-c++
BuildRequires	:	graphviz
BuildRequires	:	make
BuildRequires	:	perl
BuildRequires	:	python3
#-----------------------------------------------------------------------------
%description
Mbed TLS is a light-weight open source cryptographic and
SSL/TLS library written in C. Mbed TLS makes it easy for
developers to include cryptographic and SSL/TLS capabilities
in their (embedded) applications with as little hassle as possible

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%{_libdir}/libmbed*.so.*


#=============================================================================
%package		devel
Summary		:	Development files for %{name}

	
#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/*.h
%{_includedir}/everest/*.h
%{_includedir}/everest/kremlib/*.h
%{_includedir}/everest/kremlin/*.h
%{_includedir}/everest/kremlin/internal/*.h
%{_includedir}/everest/vs2013/*.h
%{_includedir}/psa/*.h
%{_libdir}/libmbed*.so
%{_libdir}/cmake/MbedTLS/MbedTLS*.cmake

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

cmake								\
	-S .							\
	-B bld							\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}			\
	-D CMAKE_INSTALL_LIBDIR=%{_libdir}			\
	-D CMAKE_BUILD_TYPE=Release				\
	-D CMAKE_VERBOSE_MAKEFILE=ON				\
	-D LINK_WITH_PTHREAD=ON					\
	-D INSTALL_MBEDTLS_HEADERS=ON				\
	-D ENABLE_PROGRAMS=OFF					\
	-D USE_SHARED_MBEDTLS_LIBRARY=ON			\
	-D USE_STATIC_MBEDTLS_LIBRARY=OFF			\
	-D GEN_FILES=OFF					\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}							\
	-C bld							\
	%{_smp_mflags}

%{__make}							\
	apidoc
#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
%{__make}						\
	-C bld						\
	test

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	-C bld						\
	DESTDIR=%{buildroot}				\
	install

# Library files aren't supposed to be executable,
# but RPM requires this historically
# for automatic per-file level automatic
# dependency generation at ELF binaries; see:
# - https://github.com/ARMmbed/mbedtls/commit/280165c9b39091c7c7ffe031430c7cf93ebc4dec
# - https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/PDD6RNQMII472HXM4XAUUWWZKKBGHPTO/
chmod 755 %{buildroot}%{_libdir}/*.so.*


#To remove libtool library and static library
find 							\
	%{buildroot}%{_libdir}				\
	\(						\
		 -name \*.la				\
		 -o					\
		 -name \*.a				\
	 \)						\
	-delete

#-----------------------------------------------------------------------------
%changelog
